/* -------------------------------------------------------------------------- *
 * file:	 handle_error.c                                               *
 * purpose:      provides a standard error page for all cgi's                 *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <cgic.h>
#include "nessuswc.h"

void handle_error(const char *file, int lineno, const char *msg)
{
   static char title[] = "System Error Information";

/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/

   pagehead(title, NULL, cgiOut);

   fprintf(cgiOut, "<p><center>");
   fprintf(cgiOut, "<table border=\"1\" cellspacing=\"0\" ");
   fprintf(cgiOut, "cellpadding=\"2\" width=\"540\">");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td bgcolor=\"#000080\" align=\"center\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "%s Error and additional information", CLIENT_SW_VERSION);
   fprintf(cgiOut, "</font>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td bgcolor=\"FFFFFF\"><pre>");
   fprintf(cgiOut, "** %s:%i %s\n", file, lineno, msg);
   fprintf(cgiOut, "\n%s\n", "For most common errors, see section 5 under \"Help\".");
   fprintf(cgiOut, "Otherwise, please contact me [%s]\n", CONTACT_EMAIL);
   fprintf(cgiOut, "with the info above and include a copy of the calling URL.");
   fprintf(cgiOut, "</pre></td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td bgcolor=\"#000080\" align=\"center\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "End");
   fprintf(cgiOut, "</font>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "</table>\n");
   fprintf(cgiOut, "</BODY></HTML>\n");
   exit(-1);
}
