/* ---------------------------------------------------------------------------*
 * file:        nessuswc.h                                                    *
 * purpose:     provide standard definitions accross cgi's                    *
 * author:      12/23/2004 Frank4DD                                           *
 * ---------------------------------------------------------------------------*/

#include <openssl/ssl.h>

/*********** adjust the URL and path to your cert directory below *************/
#define HOMELINK	"/nessuswc/"
#define STARTLINK	"/nessuswc/cgi-bin/scanlogin.cgi"

/* This number defines how many results are displayed in one page when    *
 * scanresults.cgi is called. A number between 10 and 25 is a good choice */
#define MAXRESDISPLAY	10

#define NESSUSD_IP	"127.0.0.1"
#define NESSUSD_PORT	1241
#define USERNAME	"guest"
/* Although we authenticate with a client certificate, the NTP protocol  *
 * still requires a password string, but its a dummy string of any value */
#define PASSWORD	"*****"

#define RESULTS_DIR	"../results"
#define TEMPLATE_DIR	"../templates"
#define CA_CERT_DIR	"../etc"
#define CA_CERT		"cacert.pem"
#define CLIENT_CERT_DIR	"../etc"
#define CLIENT_CERT	"cert_guest.pem"
#define CLIENT_PRIVKEY	"../etc/key_guest.pem"

/* default scan target ip will be displayed in scanconfig.cgi */
#define DEFAULT_TARGET_IP	"127.0.0.1"

/* enabling the whole portscan family is dangerous unless all particular
   plugins are configured right. Until the implementation of single plugin
   configuration, there is a workaround enabling only 3 fairly safe plugins.
   This workaround can be disabled by commenting it out, at your own risk.   */
#define PORTSCAN_WORKAROUND

/* refresh time of scan progress update popup window in sec, 1-3 works fine */
#define UPDWIN_REFRESH		1

/***************** this is safe to be left alone here. ************************/

#define CLIENT_SW_VERSION	"NessusWC v1.2 (07/16/2005)"
#define CLIENT_COPYRIGHTS	"GNU GPL, @2004-2005 Frank4DD"
#define CONTACT_EMAIL		"support@frank4dd.com"

#define CLIENT_NTP_VERSION "< NTP/1.2 >"
#define SERVER_NTP_VERSION "< NTP/1.2 >"

/* MAXDATASIZE should be large enough to handle a huge plugin *
 * description so we get a newline. If it is to small, we get *
 * chunks with no newline counted and its just a mess.        */
#define MAXDATASIZE 16384

/* MAXPLUGS  should be large enough to handle all plugins   *
 * we could get from the nessus daemon. If it is to small,  *
 * not all plugins can be processed. the current number is  *
 * around 5.5k. Same goes for MAXPREFS and MAXRULES,        *
 * although their numbers are much smaller (165, 0).        */
#define MAXPLUGS 10000
#define MAXCATGY 500
#define MAXFAMLY 500
#define MAXPREFS 512
#define MAXRULES 512

/* MAXTEMPL is the max number of templates for which NessusWC *
 * will generate a template file and id for.                  */
#define MAXTEMPL 999

/* we assume that theoretically each plugin could report a hole */
#define MAXRESULTS MAXPLUGS

#define USERPROMPT "User : "
#define PASSPROMPT "Password : "

/* The first line in a NessusWC generated template file identifies the origin */
#define TEMPLATE_HEAD "# This file was created automatically by NessusWC v1.2\n"

# define SCANNER_PLUGINS "10796 14274 11219 14259 10335 14272 10180 11840"

/***************** no changes required below this line ************************/

#define CIPHER_LIST "EDH-RSA-DES-CBC3-SHA:EDH-DSS-DES-CBC3-SHA:DES-CBC3-SHA:DES-CBC3-MD5:DHE-DSS-RC4-SHA:IDEA-CBC-SHA:RC4-SHA:RC4-MD5:IDEA-CBC-MD5:RC2-CBC-MD5:RC4-MD5"
#define PLUGS_START "SERVER <|> PLUGIN_LIST <|>"
#define PREFS_START "SERVER <|> PREFERENCES <|>"
#define RULES_START "SERVER <|> RULES <|>"
#define STATS_START "SERVER <|> STATUS <|>"
#define ERROR_START "SERVER <|> ERROR <|>"
#define HOLES_START "SERVER <|> HOLE <|>"
#define INFOS_START "SERVER <|> INFO <|>"
#define CLIENT_CONF "CLIENT <|> PREFERENCES <|>"
#define CLIENT_ATCK "CLIENT <|> NEW_ATTACK <|>"
#define PREFS_ERROR "SERVER <|> PREFERENCES_ERRORS <|>"
#define SEND_PLUGID "plugin_set <|>"
#define SERVER_END_MARKER "<|> SERVER"
#define SERVER_BYE_MARKER "SERVER <|> BYE <|> BYE <|> SERVER"
#define SERVER_FIN_MARKER "SERVER <|> FINISHED <|>"
#define CLIENT_END_MARKER " <|> CLIENT"
#define PREF_SEP_MARKER " <|> "

#define TEMPL_SPREF_START "begin(SERVER_PREFS)\n"
#define TEMPL_SPREF_END   "end(SERVER_PREFS)\n"
#define TEMPL_SCANR_START "begin(SCANNER_SET)\n"
#define TEMPL_SCANR_END   "end(SCANNER_SET)\n"
#define TEMPL_PLUGS_START "begin(PLUGIN_SET)\n"
#define TEMPL_PLUGS_END   "end(PLUGIN_SET)\n"
#define TEMPL_PPREF_START "begin(PLUGINS_PREFS)\n"
#define TEMPL_PPREF_END   "end(PLUGINS_PREFS)"

void pagehead(char *title, char *session, FILE *out);

#define int_error(msg)  handle_error(__FILE__, __LINE__, msg)
void handle_error(const char *file, int lineno, const char *msg);

SSL * nessus_connect(char *ip, int port, char *encr, char *cert);
void nessus_login(SSL *ssl, char *user, char *pass);
int nessus_getplugs(SSL *ssl);
void nessus_getgroups(int plugs_counter);
int nessus_getprefs(SSL *ssl);
int nessus_getrules(SSL *ssl);
void nessus_setprefs(SSL *ssl, int prefs_counter);
int nessus_setplugs(SSL *ssl);
int template_setplugs(SSL *ssl);
void nessus_target(SSL *ssl, char *target_ip, char *target_mask);
int nessus_geterrs(SSL *ssl);
void nessus_getstats(SSL *ssl, char *session);
void write_hostresults(char *t_ip, char *s_ip, char *session);
void write_hostupdates(char *session, char *t_ip, char *type, char *progress);
char * create_session_id(char *target_ip);
void get_dns(char *ip);
void get_template_name(char *file);
void get_template_date(char *file);
void get_template_prefs(char *file);
void get_template_plugs(char *file);
void update_prefslist();
void update_plugslist();
FILE * new_template_file();
void write_template_file(FILE *file, char *session_name, int prefs_counter, int famly_counter);

typedef struct plugs Plugs;
typedef struct prefs Prefs;
typedef struct rules Rules;
typedef struct catgy Catgy;
typedef struct famly Famly;

struct nessusd {
   char         ip[16];
   int          port;
   char         user[81];
   char         pass[81];
   char         cert[81];
   char         encr[81];
};

struct plugs {
                char id[6];
                char name[255];
                char category[255];
                char author[255];
                char descr[8192];
                char summary[255];
                char family[255];
              };

struct prefs {
                char name[128];
                char value[1024];
              };

struct rules {
                char command[128];
                char network[128];
              };

/* Here is our array-of-structs */
struct plugs plugslist[MAXPLUGS];
struct prefs prefslist[MAXPREFS];
struct rules ruleslist[MAXRULES];

/* Here is our array-of-pointers to the structs */
struct plugs *plugslist_ptr[MAXPLUGS];
struct prefs *prefslist_ptr[MAXPREFS];
struct rules *ruleslist_ptr[MAXRULES];

struct catgy {
		char name[sizeof(plugslist->category)];
		struct plugs *plugs_ptr[MAXPLUGS];
		int plugscount;
                int enabled;
             };

struct catgy catgylist[MAXCATGY];

struct famly {
		char name[sizeof(plugslist->family)];
		struct plugs *plugs_ptr[MAXPLUGS];
		int plugscount;
                int enabled;
             };

struct famly famlylist[MAXFAMLY];

struct result {
                 char service[81];
                 char data[8192];
                 char plugin_id[6];

               };

struct result reslist[MAXRESULTS];

struct template_plug {
   char         id[6];
   int          enabled;
};

struct template_plug template_plug_list[MAXPLUGS];

struct template_pref {
   char         name[81];
   char         value[81];
};

struct template_pref template_pref_list[MAXPREFS];

/* Here are our group counters */

int catgy_counter;
int famly_counter;
int result_counter;
int template_scanr_all;
int template_scanr_enabled;
int template_scanr_disabled;
int template_plugs_all;
int template_plugs_enabled;
int template_plugs_disabled;
int template_prefs_all;
char dns_name[255];
char template_name[81];
char template_date[81];
char templatefilestr[81];

/******************************* end webcert.h ********************************/
