/* -------------------------------------------------------------------------- *
 * file:         pagehead.c                                                   *
 * purpose:      provides the standard page header across all cgi's           *
 *                                                                            *
 *               If the session parameter is not NULL (scanprogress.cgi),     *
 *               we set the http redirect to scan results and add the         *
 *               progress update popup code to the scanprogress html header.  *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <cgic.h>
#include "nessuswc.h"

void pagehead(char* title, char *session, FILE *out) {

  char hostport[72] = "[unknown]:[none]";
  char res_page[72] = "";
 
  if(strlen(cgiServerName) != 0) {
    snprintf(hostport, sizeof(hostport), "%s:%s", cgiServerName, cgiServerPort);
  }

  if(out == NULL) out = cgiOut;

  if(out == cgiOut) cgiHeaderContentType("text/html");
  fprintf(out, "<HTML><HEAD>\n");
  fprintf(out, "<link rel=stylesheet type=text/css href=../style/style.css>");

  if(session != NULL && out == cgiOut) {
    /* here goes the html redirect code to point to the results file */
    snprintf(res_page, sizeof(res_page), "session-%s.htm", session);
    fprintf(out, "<META HTTP-EQUIV=\"Refresh\"");
    fprintf(out, "CONTENT=\"1; URL=%s/%s\">\n", RESULTS_DIR, res_page);
  }

  fprintf(out, "%s%s%s", "<TITLE>NessusWC - ", title, "</TITLE></HEAD>\n");
  fprintf(out, "<BODY bgcolor=\"006666\">\n");

/* -------------------------------------------------------------------------- *
 * start the head output                                                      *
 * ---------------------------------------------------------------------------*/

  fprintf(out, "<table border=\"0\" cellpadding =\"5\" cellspacing=\"0\" width=\"100%%\">");
  fprintf(out, "<tr>\n");
  fprintf(out, "<td><a href=%s>\n", HOMELINK);
  fprintf(out, "<img src=\"../images/nessuswc-icon.gif\" vspace=8 border=0>");
  fprintf(out, "</a></td>\n");
  fprintf(out, "<td><p align=\"center\">");
  fprintf(out, "<font face=\"Courier New,Courier\"");
  fprintf(out, "font color=\"#330000\" font size=4><b>");
  fprintf(out, "NessusWC - %s</b></font></p>", title);
  fprintf(out, "</td>\n");
  fprintf(out, "<td><img SRC=\"../images/nessuswc-logo.gif\" align=\"right\">");
  fprintf(out, "</td>");
  fprintf(out, "</tr>\n");
  fprintf(out, "</table>\n");
  fprintf(out, "<table BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%%\">");
  fprintf(out, "<tr>\n");
  fprintf(out, "<td></td>\n");
  fprintf(out, "<td WIDTH=\"25%%\" bgcolor=\"000080\" align=\"left\">");
  fprintf(out, "<font size=\"1\" face=\"Arial\" color=\"FFFFFF\"><b>");
  fprintf(out, "&nbsp;Server: %s%s", hostport, "</b></font></td>\n");
  fprintf(out, "<td WIDTH=\"50%%\" BGCOLOR=\"DCDCDC\" ");
  fprintf(out, "align=\"center\" nowrap>");
  fprintf(out, "<font face=\"Helvetica, Geneva, Arial\" size=-2>&nbsp;");
  fprintf(out, "<a href=%s>Home</a> | ", HOMELINK);
  fprintf(out, "<a href=\"../cgi-bin/scantemplates.cgi\">\n");
  fprintf(out, "Scan Templates</a> | ");
  fprintf(out, "<a href=\"../cgi-bin/scanlogin.cgi\">\n");
  fprintf(out, "Direct Scan</a> | ");
  fprintf(out, "<a href=\"../cgi-bin/scanresults.cgi\">");
  fprintf(out, "List existing Results</a> | <a href=\"../cgi-bin/help.cgi\">");
  fprintf(out, "Help</a> | <a href=\"../cgi-bin/about.cgi\">");
  fprintf(out, "About</a>");
  fprintf(out, "&nbsp;</font></td>\n");
  fprintf(out, "<td WIDTH=\"25%%\" align=\"right\" BGCOLOR=\"004444\" nowrap>");
  fprintf(out, "<font face=\"Arial\" font size=\"1\" color=\"FFFFFF\">");
  fprintf(out, "&nbsp;Generated for: ");
  if (strlen(cgiRemoteUser) != 0) fprintf(out, "%s", cgiRemoteUser);
  if (strlen(cgiRemoteAddr) != 0) fprintf(out, "%s", cgiRemoteAddr);
  else fprintf(out, "%s", "[unknown]");
  fprintf(out, "&nbsp;</font></td>\n");
  fprintf(out, "</tr></table>\n");
}
